Subject: Re: [3/4] kevent: AIO, aio_sendfile() implementation.

From: Badari Pulavarty <[email-masked]>
Date: Thu, 27 Jul 2006 08:28:00 -0700

Sébastien Dugué wrote:
> On Wed, 2006-07-26 at 09:22 -0700, Badari Pulavarty wrote:
>   
>> Ulrich Drepper wrote:
>>     
>>> Christoph Hellwig wrote:
>>>   
>>>       
>>>>> My personal opinion on existing AIO is that it is not the right design.
>>>>> Benjamin LaHaise agree with me (if I understood him right),
>>>>>       
>>>>>           
>>>> I completely agree with that aswell.
>>>>     
>>>>         
>>> I agree, too, but the current code is not the last of the line.  Suparna
>>> has a st of patches which make the current kernel aio code work much
>>> better and especially make it really usable to implement POSIX AIO.
>>>
>>> In Ottawa we were talking about submitting it and Suparna will.  We just
>>> thought about a little longer timeframe.  I guess it could be
>>> accelerated since he mostly has the patch done.  But I don't know her
>>> schedule.
>>>
>>> Important here is, don't base any decision on the current aio
>>> implementation.
>>>   
>>>       
>> Ulrich,
>>
>> Suparna mentioned your interest in making POSIX glibc aio work with 
>> kernel-aio at OLS.
>> We thought taking a re-look at the (kernel side) work BULL did, would be 
>> a nice starting
>> point. I re-based those patches to 2.6.18-rc2 and sent it to Zach Brown 
>> for review before
>> sending them out to list.
>>
>> These patches does NOT make AIO any cleaner. All they do is add 
>> functionality to support
>> POSIX AIO easier. These are
>>
>> [ PATCH 1/3 ]  Adding signal notification for event completion
>>
>> [ PATCH 2/3 ]  lio (listio) completion semantics
>>
>> [ PATCH 3/3 ] cancel_fd support
>>     
>
>   Badari,
>
>   Thanks for refreshing those patches, they have been sitting here
> for quite some time now and collected dust.
>
>   I also think Suparna's patchset for doing buffered AIO would be
> a real plus here.
>
>   
>> Suparna explained these in the following article:
>>
>> http://lwn.net/Articles/148755/
>>
>> If you think, this is a reasonable direction/approach for the kernel and 
>> you would take care
>> of glibc side of things - I can spend time on these patches, getting 
>> them to reasonable shape
>> and push for inclusion.
>>     
>
>   Ulrich, I you want to have a look at how those patches are put to
> use in libposix-aio, have a look at http://sourceforge.net/projects/paiol.
>
>   It could be a starting point for glibc.
>
>   Thanks,
>
>   Sébastien.
>
>   
Sebastien,

Suparna mentioned at Ulrich wants us to concentrate on kernel-side 
support, so that he
can look at glibc side of things (along with other work he is already 
doing). So, if we
can get an agreement on what kind of kernel support is needed - we can 
focus our
efforts on kernel side first and leave glibc enablement to capable hands 
of Uli :)

Thanks,
Badari